//----------------------------------------------------------------------------
// des.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: des.pas
//----------------------------------------------------------------------------
#ifndef desHPP
#define desHPP
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <System.hpp>
namespace Des
{
//-- type declarations -------------------------------------------------------
enum TRegistered { NotRegistered, Registered };

typedef Byte TBlock[8];

typedef TBlock *PBlock;

struct TDES_ctx
{
	bool Initialised;
	bool IVInitialised;
	Byte IV[8];
	Byte ct[8];
	Byte FRoundKeys[16][48];
	Byte FC[28];
	Byte FD[28];
	Byte FInputValue[64];
	Byte FOutputValue[64];
	Byte FL[32];
	Byte FR[32];
	Byte FFunctionResult[32];
	union
	{
		long LongBuffer[2];
		Byte ByteBuffer[8];
		
	};
} ;

enum TCipherMode { CBC, ECB, CFB, OFB };

enum TStringMode { smEncode, smNormal };

class __declspec(delphiclass) TDES;
class __declspec(pascalimplementation) TDES : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	TDES_ctx ctx;
	Byte FBuffer[4105];
	TBlock *PtrBuffer;
	TRegistered FRegistered;
	TCipherMode FCipherMode;
	TStringMode FStringMode;
	void __fastcall NagRegister(void);
	void __fastcall SetKey(const Byte * KeyToSet);
	void __fastcall F(void *FK);
	void __fastcall SetBit(void *Data, Byte Index, Byte Value);
	Byte __fastcall GetBit(void *Data, Byte Index);
	void __fastcall Shift(void *SubKeyPart);
	void __fastcall SubKey(Byte Round, void *SubKey);
	int __fastcall EncryptBuffer(int &Len);
	int __fastcall DecryptBuffer(int &Len);
	void __fastcall EncryptBlockMode(void);
	void __fastcall DecryptBlockMode(void);
	void __fastcall DES_encipher(void);
	void __fastcall DES_decipher(void);
	virtual void __fastcall SetRegistered(TRegistered Value);
	System::AnsiString __fastcall EncodeString( System::AnsiString InputString);
	System::AnsiString __fastcall DecodeString( System::AnsiString InputString);
	
public:
	int __fastcall InitialiseString(const System::AnsiString Key);
	int __fastcall InitialiseByte(const Byte * Key, const int Key_Size, int keylength);
	void __fastcall LoadIVString(const System::AnsiString IVString);
	void __fastcall LoadIVByte(const Byte * IVByte, const int IVByte_Size, int IVLength);
	int __fastcall EncryptString(const System::AnsiString Input,  System::AnsiString &Output);
	int __fastcall DecryptString(const System::AnsiString Input,  System::AnsiString &Output);
	int __fastcall EncryptBlock(const Byte * Input, Byte * Output);
	int __fastcall DecryptBlock(const Byte * Input, Byte * Output);
	int __fastcall EncryptFile(const System::AnsiString InputFileName,  System::AnsiString OutputFileName
		);
	int __fastcall DecryptFile(const System::AnsiString InputFileName,  System::AnsiString OutputFileName
		);
	void __fastcall Burn(void);
	System::AnsiString __fastcall GetVersion(void);
	
__published:
	__property TCipherMode CipherMode = {read=FCipherMode, write=FCipherMode, nodefault};
	__property TRegistered Registered = {read=FRegistered, write=SetRegistered, nodefault};
	__property TStringMode StringMode = {read=FStringMode, write=FStringMode, nodefault};
public:
	/* TComponent.Create */ __fastcall virtual TDES(Classes::TComponent* AOwner) : Classes::TComponent(
		AOwner) { }
	/* TComponent.Destroy */ __fastcall virtual ~TDES(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define OK (Byte)(0)
#define KEY_NOT_SET (Shortint)(-1)
#define ZERO_KEY_LENGTH (Shortint)(-2)
#define MSG_TOO_SHORT (Shortint)(-3)
#define IV_NOT_SET (Shortint)(-4)
#define FILE_ERROR (Shortint)(-5)
#define BLOCKSIZE (Byte)(8)
#define BUFFERLENGTH (Word)(4096)
extern void __fastcall Register(void);

}	/* namespace Des */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Des;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// des
